
; *******************************************************
; *							*
; *	Turbo Pascal Runtime Library Version 6.0	*
; *	Heap Manager					*
; *							*
; *	Copyright (C) 1988,91 Borland International	*
; *							*
; *******************************************************

; ------- Far Heap Allocation Routines by cs:dk ---------

TITLE	FARHEAP

INCLUDE	SE.ASM

.model	tpascal

.data

; Externals

	EXTRN	HeapOrg:DWORD,HeapPtr:DWORD,HeapEnd:DWORD
	EXTRN	FreeList:DWORD,HeapError:DWORD

; Local variables

AllocSize	DW	?
		DW	?	; it's far!

.code

; Externals

	EXTRN	FatalError:NEAR

; Publics

	PUBLIC	FarMemAlloc, FarMemFree

FarMemAlloc	proc	FAR  MemSize: DWORD

	MOV	AX,word ptr MemSize[0]
	MOV	DX,word ptr MemSize[2]
	CALL	FarNewMemory
	JC	@@1
	RET

@@1:	
	MOV	AX, 203
	CALL	FatalError, AX

FarMemAlloc	endp


FarMemFree	proc	FAR  Pointer: DWORD, MemSize: DWORD

	MOV	AX,word ptr MemSize[0]
	MOV	DX,word ptr MemSize[2]
	LES	CX,Pointer
	MOV	BX,ES
	CALL	FarDisMemory
	JC	@@1
	RET

@@1:	
	MOV	ax, 204
	CALL	FatalError, AX

FarMemFree	endp


; Allocate memory
; In	DX:AX = Size
; Out	DX:AX = Pointer
;	CF    = 1 if error

FarNewMemory	proc	near

	OR	AX,AX
	JNZ	@@ok
	OR	DX,DX
	JE	@@5
@@ok:
	MOV	AllocSize[0],AX
	MOV	AllocSize[2],DX
@@1:	CALL	PointerSize
	MOV	DI,OFFSET DS:FreeList
	MOV     CX,DS
	MOV	ES,CX
@@2:	MOV	CX,DI
	MOV	BX,ES
	LES	DI,ES:[DI].mNext
	MOV	SI,ES
	CMP	SI,HeapPtr.w2
	JE	@@6
	CMP	DX,ES:[DI].mSize.w2
	JA	@@2
	JB	@@3
	CMP	AX,ES:[DI].mSize.w0
	JA	@@2
@@3:	PUSH	ES
	PUSH	DI
	PUSH	BX
	PUSH	CX
	MOV	CX,ES:[DI].mNext.w0
	MOV	BX,ES:[DI].mNext.w2
	JE	@@4
	PUSH	BX
	PUSH	CX
	MOV	CX,ES:[DI].mSize.w0
	MOV	BX,ES:[DI].mSize.w2
	SUB	CX,AX
	SBB	BX,DX
	AND	CX,0FH
	ADD	AX,DI
	ADD	DX,SI
	ADD	AL,0F0H
	ADC	DX,0
	AND	AL,0FH
	MOV	DI,AX
	MOV	ES,DX
	POP	ES:[DI].mNext.w0
	POP	ES:[DI].mNext.w2
	MOV	ES:[DI].mSize.w0,CX
	MOV	ES:[DI].mSize.w2,BX
	MOV	CX,DI
	MOV	BX,ES
@@4:	POP	DI
	POP	ES
	MOV	ES:[DI].mNext.w0,CX
	MOV	ES:[DI].mNext.w2,BX
	POP	AX
	POP	DX
	CLC
@@5:	RET
@@6:	ADD	AX,DI
	ADD	DX,SI
	ADD	AL,0F0H
	ADC	DX,0
	AND	AL,0FH
	CMP	DX,HeapEnd.w2
	JB	@@7
	JA	@@8
	CMP	AX,HeapEnd.w0
	JA	@@8
@@7:	PUSH	ES
	PUSH	DI
	MOV	DI,CX
	MOV	ES,BX
	MOV	HeapPtr.w0,AX
	MOV	HeapPtr.w2,DX
	MOV	ES:[DI].mNext.w0,AX
	MOV	ES:[DI].mNext.w2,DX
	XOR	AX,AX
	PUSH	AX
	CALL	HeapError
	POP	AX
	POP	DX
	CLC
	RET
@@8:	
	PUSH	AllocSize[0]		; we are cheating, actually
	CALL	HeapError
	CMP	AL,1
	JB	@@5
	JE	@@9
	MOV	AX,AllocSize[0]
	MOV	DX,AllocSize[2]
	JMP	@@1
@@9:	XOR	AX,AX
	CWD
	RET

FarNewMemory	endp


; Dispose memory
; In	DX:AX = Size
;	BX:CX = Pointer
; Out	CF    = 1 if error

FarDisMemory	proc	near

	OR	AX,AX
	JNZ	@@ok
	OR	DX,DX
	JE	@@6
@@ok:
	TEST	CX,0FFF7H
	JNE	@@5
	CMP	BX,HeapOrg.w2
	JA	@@1
	JB	@@5
	CMP	CX,HeapOrg.w0
	JB	@@5
@@1:	CMP	BX,HeapPtr.w2
	JB	@@2
	JA	@@5
	CMP	CX,HeapPtr.w0
	JAE	@@5
@@2:	CALL	PointerSize
	MOV	DI,CX
	MOV	ES,BX
	MOV	ES:[DI].mSize.w0,AX
	MOV	ES:[DI].mSize.w2,DX
	MOV	DI,OFFSET DS:FreeList
	MOV	AX,DS
	MOV	ES,AX
@@3:	MOV	AX,DI
	MOV	DX,ES
	LES	DI,ES:[DI].mNext
	MOV	SI,ES
	CMP	BX,SI
	JA	@@3
	JB	@@4
	CMP	CX,DI
	JA	@@3
	JE	@@5
@@4:	PUSH	DX
	PUSH	AX
	CALL	MergeCheck
	POP	CX
	POP	BX
	CALL	MergeCheck
	CLC
	RET
@@5:	STC
@@6:	RET

; Merge adjacent blocks
; In	BX:CX = Target block pointer
;	ES:DI = Next block pointer
; Out	ES:DI = Target block pointer

MergeCheck	proc	near

        MOV	AX,DI
	MOV	DX,ES
	MOV	DI,CX
	MOV	ES,BX
	ADD	CX,ES:[DI].mSize.w0
	ADD	BX,ES:[DI].mSize.w2
	ADD	CL,0F0H
	ADC	BX,0
	AND	CL,0FH
	CMP	BX,DX
	JNE	@@2
	CMP	CX,AX
	JNE	@@2
	CMP	DX,HeapPtr.w2
	JNE	@@1
	CMP	AX,HeapPtr.w0
	JNE	@@1
	MOV	HeapPtr.w0,DI
	MOV	HeapPtr.w2,ES
	RET
@@1:	PUSH	DS
	PUSH	DI
	MOV	SI,AX
	MOV	DS,DX
	CLD
	MOVSW
	MOVSW
	LODSW
	XCHG	AX,DX
	LODSW
	XCHG	AX,DX
	ADD	AX,ES:[DI].w0
	ADD	DX,ES:[DI].w2
	ADD	AL,0F0H
	ADC	DX,0
	AND	AL,0FH
	STOSW
	XCHG	AX,DX
	STOSW
	POP	DI
	POP	DS
	RET
@@2:	MOV	ES:[DI].mNext.w0,AX
	MOV	ES:[DI].mNext.w2,DX
	RET

MergeCheck	endp

FarDisMemory	endp


; Convert dword size to pointer size
; In	DX:AX = Dword size
; Out	DX:AX = Pointer size

PointerSize	proc	near

	PUSH	BX
	MOV	BX, DX
	AND	BX, 000Fh		; sorry, 20Mb requests...
	ROR	BX, 1
	ROR	BX, 1
	ROR	BX, 1
	ROR	BX, 1

	ADD	AX,7
	MOV	DX,AX
	RCR	DX,1
	SHR	DX,1
	SHR	DX,1
	SHR	DX,1
	AND	AX,8

	ADD	DX, BX
	POP	BX
	RET

PointerSize	endp


END
