
unit FarHeap;

{$F-,S-,R-}

interface

(* C-style routines *)
function FarMemAlloc(Size: Longint): Pointer;
procedure FarMemFree(P: Pointer; Size: Longint);

(* TP-style routines *)
procedure FarGetMem(var P: Pointer; Size: Longint);
procedure FarFreeMem(var P: Pointer; Size: Longint);


implementation

function FarMemAlloc(Size: Longint): Pointer; external; {FARHEAP.OBJ}
procedure FarMemFree(P: Pointer; Size: Longint); external; {FARHEAP.OBJ}
{$L FARHEAP.OBJ}

procedure FarGetMem(var P: Pointer; Size: Longint);
begin
     P := FarMemAlloc(Size);
end;

procedure FarFreeMem(var P: Pointer; Size: Longint);
begin
     FarMemFree(P, Size);
     P := Nil;                  (* for safety *)
end;

(* internal - called by FarMemAlloc/FarMemFree on memory fault *)
procedure FatalError(Code: Word);
begin
	RunError(Code);
end;

end.
